//=============================================================================
// SuperMine 
// Written by nOs*Badger
// Heavily optimized by Higor
//=============================================================================
class SuperMine extends Mine;

//First event in creation order
event Spawned()
{
	local PlayerStart P;
	local byte aTeam;

	Super(sgBuilding).Spawned();

	if ( (Pawn(Owner) == none) || (Pawn(Owner).PlayerReplicationInfo == none) )
		return;

	aTeam = Pawn(Owner).PlayerReplicationInfo.Team;
	ForEach RadiusActors (class'PlayerStart', P, 105)
	{
		if ( P.TeamNumber != aTeam )
		{
			Destroy();
			return;
		}
	}
}

function TriggerSize()
{
	MyTrigger.SetCollisionSize( 100, 100);
}

function bool ShouldDetonate()
{
	local int i;
	local bool bSuccess;

	For ( i=iCheckOn-1 ; i>=0 ; i-- )
	{
		if ( !MyTrigger.IsTouching( CheckOn[i]) ) //Clean up the whole list before returning
		{
			CheckOn[i] = CheckOn[--iCheckOn];
			CheckOn[iCheckOn] = none;
			continue;
		}

		if ( !bSuccess && (CheckOn[i].Health > 0) && (VSize( CheckOn[i].Location - Location) < (100 + CheckOn[i].CollisionRadius)) && FastTrace(CheckOn[i].Location) )
			bSuccess = true;
	}
	return bSuccess;
}


function Damage()
{
	local int i, j, iP;
	local Pawn p, pAward, pList[16];

	PlaySound(Sound'SharpExplosion',, 4.0);
	pAward = GetAwardedPlayer();

	//Hack fix, This iterator doesn't include CollisionRadius, use 25 extra for max detection (for monster support)!!
	ForEach VisibleCollidingActors (class'Pawn', p, 100+(int(Grade)*35)+25,,true) 
	{
		if ( (p.Health > 0) && ShouldAttack(P) )
		{
			pList[iP++] = p;
			if ( iP >= arraycount(pList) )
				break;
		}
	}

	i=Grade;	
	While ( i-- >= 0 )
		Spawn (class'MineExplosion',,, Location + VRand() * 40);

	While ( j < iP )
	{
		i = 0;
		While ( VSize( Location - pList[j].Location ) > 100+17+(i*35) )
			i++;
		if ( i > Grade )
		{
			j++;
			continue;
		}
		i = 1 + int(Grade) - i;

		pList[j].TakeDamage( (Grade+1) * i * 15, instigator, normal( Location - pList[j].Location) * 0.5 * (pList[j].CollisionHeight + pList[j].CollisionRadius), vect(0,0,0), 'mine');
		sgPRI(pAward.PlayerReplicationInfo).AddRU( (Grade+1) * i * 2);
		j++;
	}
	sgPRI(pAward.PlayerReplicationInfo).AddRU(48);

	Energy -= 200;
	if ( Energy <= 0 )
		Destruct();
}

defaultproperties
{
     bOnlyOwnerRemove=True
     BuildingName="Super Mine"
     BuildCost=750
     UpgradeCost=30
     MaxEnergy=1000.000000
     SpriteScale=0.300000
     DSofMFX=1.600000
}
